// Automatically generated rust module for 'messages.proto' file

#![allow(non_snake_case)]
#![allow(non_upper_case_globals)]
#![allow(non_camel_case_types)]
#![allow(unused_imports)]
#![allow(unknown_lints)]
#![allow(clippy::all)]
#![cfg_attr(rustfmt, rustfmt_skip)]


use std::borrow::Cow;
use quick_protobuf::{MessageInfo, MessageRead, MessageWrite, BytesReader, Writer, WriterBackend, Result};
use quick_protobuf::sizeofs::*;
use super::*;

#[derive(Debug, PartialEq, Eq, Clone, Copy)]
pub enum Fail {
    UnrecognisedKey = 1,
    ExpiredKey = 2,
    Other = 3,
}

impl Default for Fail {
    fn default() -> Self {
        Fail::UnrecognisedKey
    }
}

impl From<i32> for Fail {
    fn from(i: i32) -> Self {
        match i {
            1 => Fail::UnrecognisedKey,
            2 => Fail::ExpiredKey,
            3 => Fail::Other,
            _ => Self::default(),
        }
    }
}

impl<'a> From<&'a str> for Fail {
    fn from(s: &'a str) -> Self {
        match s {
            "UnrecognisedKey" => Fail::UnrecognisedKey,
            "ExpiredKey" => Fail::ExpiredKey,
            "Other" => Fail::Other,
            _ => Self::default(),
        }
    }
}

#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Debug, Default, PartialEq, Clone)]
pub struct SignRequest<'a> {
    pub vkey: Cow<'a, [u8]>,
    pub body: Cow<'a, [u8]>,
    pub sig: Cow<'a, [u8]>,
}

impl<'a> MessageRead<'a> for SignRequest<'a> {
    fn from_reader(r: &mut BytesReader, bytes: &'a [u8]) -> Result<Self> {
        let mut msg = Self::default();
        while !r.is_eof() {
            match r.next_tag(bytes) {
                Ok(10) => msg.vkey = r.read_bytes(bytes).map(Cow::Borrowed)?,
                Ok(18) => msg.body = r.read_bytes(bytes).map(Cow::Borrowed)?,
                Ok(26) => msg.sig = r.read_bytes(bytes).map(Cow::Borrowed)?,
                Ok(t) => { r.read_unknown(bytes, t)?; }
                Err(e) => return Err(e),
            }
        }
        Ok(msg)
    }
}

impl<'a> MessageWrite for SignRequest<'a> {
    fn get_size(&self) -> usize {
        0
        + if self.vkey == Cow::Borrowed(b"") { 0 } else { 1 + sizeof_len((&self.vkey).len()) }
        + if self.body == Cow::Borrowed(b"") { 0 } else { 1 + sizeof_len((&self.body).len()) }
        + if self.sig == Cow::Borrowed(b"") { 0 } else { 1 + sizeof_len((&self.sig).len()) }
    }

    fn write_message<W: WriterBackend>(&self, w: &mut Writer<W>) -> Result<()> {
        if self.vkey != Cow::Borrowed(b"") { w.write_with_tag(10, |w| w.write_bytes(&**&self.vkey))?; }
        if self.body != Cow::Borrowed(b"") { w.write_with_tag(18, |w| w.write_bytes(&**&self.body))?; }
        if self.sig != Cow::Borrowed(b"") { w.write_with_tag(26, |w| w.write_bytes(&**&self.sig))?; }
        Ok(())
    }
}

#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Debug, Default, PartialEq, Clone)]
pub struct SignResponse<'a> {
    pub result: messages::mod_SignResponse::OneOfresult<'a>,
}

impl<'a> MessageRead<'a> for SignResponse<'a> {
    fn from_reader(r: &mut BytesReader, bytes: &'a [u8]) -> Result<Self> {
        let mut msg = Self::default();
        while !r.is_eof() {
            match r.next_tag(bytes) {
                Ok(10) => msg.result = messages::mod_SignResponse::OneOfresult::okay(r.read_message::<messages::Okay>(bytes)?),
                Ok(16) => msg.result = messages::mod_SignResponse::OneOfresult::fail(r.read_enum(bytes)?),
                Ok(t) => { r.read_unknown(bytes, t)?; }
                Err(e) => return Err(e),
            }
        }
        Ok(msg)
    }
}

impl<'a> MessageWrite for SignResponse<'a> {
    fn get_size(&self) -> usize {
        0
        + match self.result {
            messages::mod_SignResponse::OneOfresult::okay(ref m) => 1 + sizeof_len((m).get_size()),
            messages::mod_SignResponse::OneOfresult::fail(ref m) => 1 + sizeof_varint(*(m) as u64),
            messages::mod_SignResponse::OneOfresult::None => 0,
    }    }

    fn write_message<W: WriterBackend>(&self, w: &mut Writer<W>) -> Result<()> {
        match self.result {            messages::mod_SignResponse::OneOfresult::okay(ref m) => { w.write_with_tag(10, |w| w.write_message(m))? },
            messages::mod_SignResponse::OneOfresult::fail(ref m) => { w.write_with_tag(16, |w| w.write_enum(*m as i32))? },
            messages::mod_SignResponse::OneOfresult::None => {},
    }        Ok(())
    }
}

pub mod mod_SignResponse {

use super::*;

#[derive(Debug, PartialEq, Clone)]
pub enum OneOfresult<'a> {
    okay(messages::Okay<'a>),
    fail(messages::Fail),
    None,
}

impl<'a> Default for OneOfresult<'a> {
    fn default() -> Self {
        OneOfresult::None
    }
}

}

#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Debug, Default, PartialEq, Clone)]
pub struct Okay<'a> {
    pub sig: Cow<'a, [u8]>,
}

impl<'a> MessageRead<'a> for Okay<'a> {
    fn from_reader(r: &mut BytesReader, bytes: &'a [u8]) -> Result<Self> {
        let mut msg = Self::default();
        while !r.is_eof() {
            match r.next_tag(bytes) {
                Ok(10) => msg.sig = r.read_bytes(bytes).map(Cow::Borrowed)?,
                Ok(t) => { r.read_unknown(bytes, t)?; }
                Err(e) => return Err(e),
            }
        }
        Ok(msg)
    }
}

impl<'a> MessageWrite for Okay<'a> {
    fn get_size(&self) -> usize {
        0
        + if self.sig == Cow::Borrowed(b"") { 0 } else { 1 + sizeof_len((&self.sig).len()) }
    }

    fn write_message<W: WriterBackend>(&self, w: &mut Writer<W>) -> Result<()> {
        if self.sig != Cow::Borrowed(b"") { w.write_with_tag(10, |w| w.write_bytes(&**&self.sig))?; }
        Ok(())
    }
}

